SystemOrganization addCategory: #'Gradualtalk-Parser'!

PPToken subclass: #GTSmalltalkToken
	instanceVariableNames: 'comments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Gradualtalk-Parser'!

!GTSmalltalkToken methodsFor: 'accessing' stamp: 'EstebanAllende 1/25/2013 17:56'!
comments
	^ comments! !

!GTSmalltalkToken methodsFor: 'accessing' stamp: 'EstebanAllende 1/25/2013 17:56'!
comments: anArray
	comments := anArray! !

!GTSmalltalkToken methodsFor: 'compatiblity' stamp: 'EstebanAllende 1/25/2013 17:56'!
length
	^ self size! !

!PPParser methodsFor: '*Gradualtalk-Parser' stamp: 'EstebanAllende 2/28/2013 13:59'!
smalltalkToken
	^ GTSmalltalkTokenParser on: self! !

!RBMethodNode class methodsFor: '*Gradualtalk-Parser' stamp: 'EstebanAllende 2/28/2013 13:00'!
selectorParts: tokenCollection arguments: variableNodes paramTypes: paramTypes returnType:  returnType
	|node|
	node:=self selectorParts: tokenCollection arguments: variableNodes .
	
	node propertyAt: #returnType put: (returnType ifNil:[GradualtalkParser defaultType]).
	1 to: variableNodes size do: [:idx | (variableNodes at: idx) propertyAt: #type put: ((paramTypes at: idx) ifNil:[GradualtalkParser defaultType])].
	
	^ node! !

!RBProgramNode methodsFor: '*Gradualtalk-Parser' stamp: 'EstebanAllende 2/28/2013 14:00'!
addComments: aCollection
	aCollection isEmptyOrNil ifTrue: [^self].
 	comments ifNil: [ comments := OrderedCollection new ].
	comments addAll: aCollection.
	! !

!Metaclass methodsFor: '*Gradualtalk-Parser' stamp: 'EstebanAllende 3/27/2013 16:07'!
instanceVariableNames: instVarString 
	"Declare additional named variables for my instance."
	|varParser res|
	varParser :=( (GTVariablesParser new)
		class: self;
		ivar: instVarString).
	res :=(ClassBuilder new)
		class: self
		instanceVariableNames: varParser oldIvar.
	varParser annotateVars.
	^res.! !

!OCParser methodsFor: '*Gradualtalk-Parser' stamp: 'EstebanAllende 1/24/2013 18:14'!
realParserClass

	^ GradualtalkParser! !

PPCompositeParser subclass: #GTSmalltalkGrammar
	instanceVariableNames: 'array arrayItem arrayLiteral arrayLiteralArray assignment assignmentToken binary binaryExpression binaryMessage binaryMethod binaryPragma binaryToken block blockArgument blockArguments blockArgumentsWith blockArgumentsWithout blockBody byteLiteral byteLiteralArray cascadeExpression cascadeMessage char charLiteral charToken expression falseLiteral falseToken identifier identifierToken keyword keywordExpression keywordMessage keywordMethod keywordPragma keywordToken literal message method methodDeclaration methodSequence multiword nilLiteral nilToken number numberLiteral numberToken parens period periodToken pragma pragmaMessage pragmas primary return sequence startExpression startMethod statements string stringLiteral stringToken symbol symbolLiteral symbolLiteralArray temporaries trueLiteral trueToken unary unaryExpression unaryMessage unaryMethod unaryPragma unaryToken variable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Gradualtalk-Parser'!

!GTSmalltalkGrammar commentStamp: '<historical>' prior: 0!
A parser for Smalltalk methods and expressions.!

!GTSmalltalkGrammar class methodsFor: 'accessing' stamp: 'EstebanAllende 1/24/2013 18:06'!
parseExpression: aString
	^ self new parseExpression: aString! !

!GTSmalltalkGrammar class methodsFor: 'accessing' stamp: 'EstebanAllende 1/24/2013 18:06'!
parseExpression: aString onError: aBlock
	^ self new parseExpression: aString onError: aBlock! !

!GTSmalltalkGrammar class methodsFor: 'accessing' stamp: 'EstebanAllende 1/24/2013 18:06'!
parseMethod: aString
	^ self new parseMethod: aString! !

!GTSmalltalkGrammar class methodsFor: 'accessing' stamp: 'EstebanAllende 1/24/2013 18:06'!
parseMethod: aString onError: aBlock
	^ self new parseMethod: aString onError: aBlock! !

!GTSmalltalkGrammar methodsFor: 'grammar' stamp: 'EstebanAllende 1/24/2013 18:06'!
array
	^ ${ asParser smalltalkToken , (expression delimitedBy: periodToken) optional , $} asParser smalltalkToken! !

!GTSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'EstebanAllende 1/24/2013 18:06'!
arrayItem
	^ literal / symbolLiteralArray / arrayLiteralArray / byteLiteralArray! !

!GTSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'EstebanAllende 1/24/2013 18:06'!
arrayLiteral
	^ '#(' asParser smalltalkToken , arrayItem star , $) asParser smalltalkToken! !

!GTSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'EstebanAllende 1/24/2013 18:06'!
arrayLiteralArray
	^ $( asParser smalltalkToken , arrayItem star , $) asParser smalltalkToken! !

!GTSmalltalkGrammar methodsFor: 'grammar' stamp: 'EstebanAllende 1/24/2013 18:06'!
assignment
	^ variable , assignmentToken! !

!GTSmalltalkGrammar methodsFor: 'token' stamp: 'EstebanAllende 4/26/2013 10:52'!
assignmentToken
	^ ':=' asParser smalltalkToken! !

!GTSmalltalkGrammar methodsFor: 'primitives' stamp: 'EstebanAllende 1/24/2013 18:06'!
binary
	^ (PPPredicateObjectParser anyOf: '!!%&*+,-/<=>?@\|~') plus! !

!GTSmalltalkGrammar methodsFor: 'grammar-messages' stamp: 'EstebanAllende 1/24/2013 18:06'!
binaryExpression
	^ unaryExpression , binaryMessage star! !

!GTSmalltalkGrammar methodsFor: 'grammar-messages' stamp: 'EstebanAllende 1/24/2013 18:06'!
binaryMessage
	^ (binaryToken , unaryExpression) ==> [ :nodes | 
		Array 
			with: (Array with: nodes first)
			with: (Array with: nodes second) ]! !

!GTSmalltalkGrammar methodsFor: 'grammar-methods' stamp: 'EstebanAllende 1/24/2013 18:06'!
binaryMethod
	^ (binaryToken , variable) ==> [ :nodes | 
		Array 
			with: (Array with: nodes first)
			with: (Array with: nodes second) ]! !

!GTSmalltalkGrammar methodsFor: 'grammar-pragmas' stamp: 'EstebanAllende 1/24/2013 18:06'!
binaryPragma
	^ (binaryToken , arrayItem) ==> [ :nodes | 
		Array 
			with: (Array with: nodes first)
			with: (Array with: nodes second) ]! !

!GTSmalltalkGrammar methodsFor: 'token' stamp: 'EstebanAllende 1/24/2013 18:06'!
binaryToken
	^ binary smalltalkToken! !

!GTSmalltalkGrammar methodsFor: 'grammar-blocks' stamp: 'EstebanAllende 1/24/2013 18:06'!
block
	^ $[ asParser smalltalkToken , blockBody , $] asParser smalltalkToken! !

!GTSmalltalkGrammar methodsFor: 'grammar-blocks' stamp: 'EstebanAllende 1/24/2013 18:06'!
blockArgument
	^ $: asParser smalltalkToken , variable! !

!GTSmalltalkGrammar methodsFor: 'grammar-blocks' stamp: 'EstebanAllende 1/24/2013 18:06'!
blockArguments
	^ blockArgumentsWith / blockArgumentsWithout! !

!GTSmalltalkGrammar methodsFor: 'grammar-blocks' stamp: 'EstebanAllende 1/24/2013 18:06'!
blockArgumentsWith
	^ blockArgument plus , ($| asParser smalltalkToken / ($] asParser smalltalkToken and ==> [ :node | nil ]))! !

!GTSmalltalkGrammar methodsFor: 'grammar-blocks' stamp: 'EstebanAllende 1/24/2013 18:06'!
blockArgumentsWithout
	^ nil asParser ==> [ :nodes | Array with: #() with: nil ]! !

!GTSmalltalkGrammar methodsFor: 'grammar-blocks' stamp: 'EstebanAllende 1/24/2013 18:06'!
blockBody
	^ blockArguments , sequence! !

!GTSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'EstebanAllende 1/24/2013 18:06'!
byteLiteral
	^ '#[' asParser smalltalkToken , numberLiteral star , $] asParser smalltalkToken! !

!GTSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'EstebanAllende 1/24/2013 18:06'!
byteLiteralArray
	^ $[ asParser smalltalkToken , numberLiteral star , $] asParser smalltalkToken! !

!GTSmalltalkGrammar methodsFor: 'grammar-messages' stamp: 'EstebanAllende 1/24/2013 18:06'!
cascadeExpression
	^ keywordExpression , cascadeMessage star! !

!GTSmalltalkGrammar methodsFor: 'grammar-messages' stamp: 'EstebanAllende 1/24/2013 18:06'!
cascadeMessage
	^ $; asParser smalltalkToken , message! !

!GTSmalltalkGrammar methodsFor: 'primitives' stamp: 'EstebanAllende 1/24/2013 18:06'!
char
	^ $$ asParser , #any asParser! !

!GTSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'EstebanAllende 1/24/2013 18:06'!
charLiteral
	^ charToken! !

!GTSmalltalkGrammar methodsFor: 'token' stamp: 'EstebanAllende 1/24/2013 18:06'!
charToken
	^ char smalltalkToken! !

!GTSmalltalkGrammar methodsFor: 'grammar' stamp: 'EstebanAllende 1/24/2013 18:06'!
expression
	^ assignment star , cascadeExpression! !

!GTSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'EstebanAllende 1/24/2013 18:06'!
falseLiteral
	^ falseToken! !

!GTSmalltalkGrammar methodsFor: 'token' stamp: 'EstebanAllende 1/24/2013 18:06'!
falseToken
	^ ('false' asParser , #word asParser not) smalltalkToken! !

!GTSmalltalkGrammar methodsFor: 'primitives' stamp: 'EstebanAllende 4/26/2013 10:53'!
identifier
	^ (PPPredicateObjectParser
			on: [ :each | each isLetter or: [ each = $_ ] ]
			message: 'letter expected') ,
	   (PPPredicateObjectParser
			on: [ :each | each isAlphaNumeric or: [ each = $_ ] ]
			message: 'letter or digit expected') star! !

!GTSmalltalkGrammar methodsFor: 'token' stamp: 'EstebanAllende 1/24/2013 18:06'!
identifierToken
	^ identifier smalltalkToken! !

!GTSmalltalkGrammar methodsFor: 'primitives' stamp: 'EstebanAllende 1/24/2013 18:06'!
keyword
	^ identifier , $: asParser! !

!GTSmalltalkGrammar methodsFor: 'grammar-messages' stamp: 'EstebanAllende 1/24/2013 18:06'!
keywordExpression
	^ binaryExpression , keywordMessage optional! !

!GTSmalltalkGrammar methodsFor: 'grammar-messages' stamp: 'EstebanAllende 1/24/2013 18:06'!
keywordMessage
	^ (keywordToken , binaryExpression) plus ==> [ :nodes | 
		Array 
			with: (nodes collect: [ :each | each first ])
			with: (nodes collect: [ :each | each second ]) ]! !

!GTSmalltalkGrammar methodsFor: 'grammar-methods' stamp: 'EstebanAllende 1/24/2013 18:06'!
keywordMethod
	^ (keywordToken , variable) plus ==> [ :nodes | 
		Array 
			with: (nodes collect: [ :each | each first ])
			with: (nodes collect: [ :each | each second ]) ]! !

!GTSmalltalkGrammar methodsFor: 'grammar-pragmas' stamp: 'EstebanAllende 1/24/2013 18:06'!
keywordPragma
	^ (keywordToken , arrayItem) plus ==> [ :nodes | 
		Array 
			with: (nodes collect: [ :each | each first ])
			with: (nodes collect: [ :each | each second ]) ]! !

!GTSmalltalkGrammar methodsFor: 'token' stamp: 'EstebanAllende 1/24/2013 18:06'!
keywordToken
	^ keyword smalltalkToken! !

!GTSmalltalkGrammar methodsFor: 'grammar' stamp: 'EstebanAllende 1/24/2013 18:06'!
literal
	^ numberLiteral / stringLiteral / charLiteral / arrayLiteral / byteLiteral / symbolLiteral / nilLiteral / trueLiteral / falseLiteral! !

!GTSmalltalkGrammar methodsFor: 'grammar' stamp: 'EstebanAllende 1/24/2013 18:06'!
message
	^ keywordMessage / binaryMessage / unaryMessage! !

!GTSmalltalkGrammar methodsFor: 'grammar' stamp: 'EstebanAllende 1/24/2013 18:06'!
method
	^ methodDeclaration , methodSequence! !

!GTSmalltalkGrammar methodsFor: 'grammar' stamp: 'EstebanAllende 1/24/2013 18:06'!
methodDeclaration
	^ keywordMethod / unaryMethod / binaryMethod! !

!GTSmalltalkGrammar methodsFor: 'grammar' stamp: 'EstebanAllende 1/24/2013 18:06'!
methodSequence
	^ periodToken star , pragmas , periodToken star , temporaries , periodToken star , pragmas , periodToken star , statements! !

!GTSmalltalkGrammar methodsFor: 'primitives' stamp: 'EstebanAllende 1/24/2013 18:06'!
multiword
	^ keyword plus! !

!GTSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'EstebanAllende 1/24/2013 18:06'!
nilLiteral
	^ nilToken! !

!GTSmalltalkGrammar methodsFor: 'token' stamp: 'EstebanAllende 1/24/2013 18:06'!
nilToken
	^ ('nil' asParser , #word asParser not) smalltalkToken! !

!GTSmalltalkGrammar methodsFor: 'primitives' stamp: 'EstebanAllende 2/20/2013 20:20'!
number
	^ ($- asParser optional , #digit asParser) and , [ :stream | 
		[ Number readSmalltalkSyntaxFrom: stream ] 
			on: Error
			do: [ :err | PPFailure message: err messageText at: stream position ] ] 
				asParser! !

!GTSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'EstebanAllende 1/24/2013 18:06'!
numberLiteral
	^ numberToken! !

!GTSmalltalkGrammar methodsFor: 'token' stamp: 'EstebanAllende 1/24/2013 18:06'!
numberToken
	^ number smalltalkToken! !

!GTSmalltalkGrammar methodsFor: 'grammar' stamp: 'EstebanAllende 1/24/2013 18:06'!
parens
	^ $( asParser smalltalkToken , expression , $) asParser smalltalkToken! !

!GTSmalltalkGrammar methodsFor: 'parsing' stamp: 'EstebanAllende 1/24/2013 18:06'!
parseExpression: aString 
	^ self parseExpression: aString onError: [ :msg :pos | self error: msg ]! !

!GTSmalltalkGrammar methodsFor: 'parsing' stamp: 'EstebanAllende 1/24/2013 18:06'!
parseExpression: aString onError: aBlock
	^ startExpression parse: aString onError: aBlock! !

!GTSmalltalkGrammar methodsFor: 'parsing' stamp: 'EstebanAllende 1/24/2013 18:06'!
parseMethod: aString 
	^ self parseMethod: aString onError: [ :msg :pos | self error: msg ]! !

!GTSmalltalkGrammar methodsFor: 'parsing' stamp: 'EstebanAllende 1/24/2013 18:06'!
parseMethod: aString onError: aBlock
	^ startMethod parse: aString onError: aBlock! !

!GTSmalltalkGrammar methodsFor: 'primitives' stamp: 'EstebanAllende 1/24/2013 18:06'!
period
	^ $. asParser! !

!GTSmalltalkGrammar methodsFor: 'token' stamp: 'EstebanAllende 1/24/2013 18:06'!
periodToken
	^ period smalltalkToken! !

!GTSmalltalkGrammar methodsFor: 'grammar' stamp: 'EstebanAllende 1/24/2013 18:06'!
pragma
	^ $< asParser smalltalkToken , pragmaMessage , $> asParser smalltalkToken! !

!GTSmalltalkGrammar methodsFor: 'grammar-pragmas' stamp: 'EstebanAllende 1/24/2013 18:06'!
pragmaMessage
	^ keywordPragma / unaryPragma / binaryPragma! !

!GTSmalltalkGrammar methodsFor: 'grammar' stamp: 'EstebanAllende 1/24/2013 18:06'!
pragmas
	^ pragma star! !

!GTSmalltalkGrammar methodsFor: 'grammar' stamp: 'EstebanAllende 1/24/2013 18:06'!
primary
	^ literal / variable / block / parens / array! !

!GTSmalltalkGrammar methodsFor: 'grammar' stamp: 'EstebanAllende 1/24/2013 18:06'!
return
	^ $^ asParser smalltalkToken , expression! !

!GTSmalltalkGrammar methodsFor: 'grammar' stamp: 'EstebanAllende 1/24/2013 18:06'!
sequence
	^ temporaries , periodToken star , statements! !

!GTSmalltalkGrammar methodsFor: 'accessing' stamp: 'EstebanAllende 1/24/2013 18:06'!
start
	"Default start production."

	^ startMethod! !

!GTSmalltalkGrammar methodsFor: 'accessing' stamp: 'EstebanAllende 1/24/2013 18:06'!
startExpression
	"Start production for the expression."

	^ sequence end! !

!GTSmalltalkGrammar methodsFor: 'accessing' stamp: 'EstebanAllende 1/24/2013 18:06'!
startMethod
	"Start production for the method."

	^ method end! !

!GTSmalltalkGrammar methodsFor: 'grammar' stamp: 'EstebanAllende 1/24/2013 18:06'!
statements
	^ 	(expression wrapped , ((periodToken plus , statements ==> [ :nodes | nodes first , nodes last ])
								/ periodToken star)
			==> [ :nodes | (Array with: nodes first) , (nodes last) ])
	/	(return , periodToken star
			==> [ :nodes | (Array with: nodes first) , (nodes last) ])
	/	(periodToken star)! !

!GTSmalltalkGrammar methodsFor: 'primitives' stamp: 'EstebanAllende 1/24/2013 18:06'!
string
	^ $' asParser , ('''''' asParser / $' asParser negate) star , $' asParser! !

!GTSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'EstebanAllende 1/24/2013 18:06'!
stringLiteral
	^ stringToken! !

!GTSmalltalkGrammar methodsFor: 'token' stamp: 'EstebanAllende 1/24/2013 18:06'!
stringToken
	^ string smalltalkToken! !

!GTSmalltalkGrammar methodsFor: 'primitives' stamp: 'EstebanAllende 1/24/2013 18:06'!
symbol
	^ unary / binary / multiword / string! !

!GTSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'EstebanAllende 1/24/2013 18:06'!
symbolLiteral
	"This is totally fucked up: The Pharo compiler allows multiple #, arbitrary spaces between the # and the symbol, as well as comments inbetween. And yes, it is used."

	^ $# asParser smalltalkToken plus , symbol smalltalkToken ==> [ :tokens | tokens first copyWith: tokens last ]! !

!GTSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'EstebanAllende 1/24/2013 18:06'!
symbolLiteralArray
	^ symbol smalltalkToken! !

!GTSmalltalkGrammar methodsFor: 'grammar' stamp: 'EstebanAllende 1/24/2013 18:06'!
temporaries
	^ ($| asParser smalltalkToken , variable star , $| asParser smalltalkToken) optional ==> [ :nodes | nodes ifNil: [ #() ] ]! !

!GTSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'EstebanAllende 1/24/2013 18:06'!
trueLiteral
	^ trueToken! !

!GTSmalltalkGrammar methodsFor: 'token' stamp: 'EstebanAllende 1/24/2013 18:06'!
trueToken
	^ ('true' asParser , #word asParser not) smalltalkToken! !

!GTSmalltalkGrammar methodsFor: 'primitives' stamp: 'EstebanAllende 1/24/2013 18:06'!
unary
	^ identifier , $: asParser not! !

!GTSmalltalkGrammar methodsFor: 'grammar-messages' stamp: 'EstebanAllende 1/24/2013 18:06'!
unaryExpression
	^ primary , unaryMessage star! !

!GTSmalltalkGrammar methodsFor: 'grammar-messages' stamp: 'EstebanAllende 1/24/2013 18:06'!
unaryMessage
	^ unaryToken ==> [ :node | 
		Array 
			with: (Array with: node)
			with: Array new ]! !

!GTSmalltalkGrammar methodsFor: 'grammar-methods' stamp: 'EstebanAllende 1/24/2013 18:06'!
unaryMethod
	^ identifierToken ==> [ :node | 
		Array 
			with: (Array with: node)
			with: Array new ]! !

!GTSmalltalkGrammar methodsFor: 'grammar-pragmas' stamp: 'EstebanAllende 1/24/2013 18:06'!
unaryPragma
	^ identifierToken ==> [ :node | 
		Array 
			with: (Array with: node)
			with: (Array new) ]! !

!GTSmalltalkGrammar methodsFor: 'token' stamp: 'EstebanAllende 1/24/2013 18:06'!
unaryToken
	^ unary smalltalkToken! !

!GTSmalltalkGrammar methodsFor: 'grammar' stamp: 'EstebanAllende 1/24/2013 18:06'!
variable
	^ identifierToken! !

GTSmalltalkGrammar subclass: #GradualtalkGrammar
	instanceVariableNames: 'type parenType cast parenToken bootstrapType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Gradualtalk-Parser'!

GradualtalkGrammar class
	instanceVariableNames: 'typeGrammar'!

GradualtalkGrammar class
	instanceVariableNames: 'typeGrammar'!

GradualtalkGrammar subclass: #GTSmalltalkParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Gradualtalk-Parser'!

!GTSmalltalkParser commentStamp: '<historical>' prior: 0!
Enhances the Smalltalk grammar with production actions to build parse-tree nodes of the refactoring browser.
!

!GTSmalltalkParser methodsFor: 'private' stamp: 'EstebanAllende 1/25/2013 17:57'!
addStatements: aCollection into: aNode
	aCollection isNil 
		ifTrue: [ ^ aNode ].
	aCollection do: [ :each |
		each class == GTSmalltalkToken
			ifFalse: [ aNode addNode:  each ]
			ifTrue: [
				aNode statements isEmpty
					ifTrue: [ aNode addComments: each comments ]
					ifFalse: [ aNode statements last addComments: each comments ].
				aNode periods: (aNode periods asOrderedCollection
					addLast: each start;
					yourself) ] ].
	^ aNode! !

!GTSmalltalkParser methodsFor: 'grammar' stamp: 'EstebanAllende 1/24/2013 18:07'!
array
	^ super array map: [ :openNode :statementNodes :closeNode |
		(self buildArray: statementNodes)
			left: openNode start;
			right: closeNode start;
			yourself ]! !

!GTSmalltalkParser methodsFor: 'grammar-literals' stamp: 'EstebanAllende 1/24/2013 18:07'!
arrayLiteral
	^ super arrayLiteral ==> [ :nodes | RBLiteralArrayNode startPosition: nodes first start contents: nodes second stopPosition: nodes last start isByteArray: false ]! !

!GTSmalltalkParser methodsFor: 'grammar-literals' stamp: 'EstebanAllende 1/24/2013 18:07'!
arrayLiteralArray
	^ super arrayLiteralArray ==> [ :nodes | RBLiteralArrayNode startPosition: nodes first start contents: nodes second stopPosition: nodes last start isByteArray: false ]! !

!GTSmalltalkParser methodsFor: 'token' stamp: 'EstebanAllende 1/28/2013 15:19'!
assignmentToken
	^ super assignmentToken ==> 
		[:token| 
			(token length == 1) 
				ifTrue: [RBShortAssignmentToken start: token start]
				ifFalse: [RBAssignmentToken start: token start]
		]! !

!GTSmalltalkParser methodsFor: 'grammar-messages' stamp: 'EstebanAllende 1/24/2013 18:07'!
binaryExpression
	^ super binaryExpression map: [ :receiverNode :messageNodes | self build: receiverNode messages: messageNodes ]! !

!GTSmalltalkParser methodsFor: 'token' stamp: 'EstebanAllende 2/28/2013 12:27'!
binaryToken
	^ super binaryToken ==> [ :token | (RBBinarySelectorToken value: token inputValue asSymbol start: token start) comments: token comments; yourself ]! !

!GTSmalltalkParser methodsFor: 'grammar-blocks' stamp: 'EstebanAllende 1/24/2013 18:07'!
block
	^ super block map: [ :leftToken :blockNode :rightToken | blockNode left: leftToken start; right: rightToken start ]! !

!GTSmalltalkParser methodsFor: 'grammar-blocks' stamp: 'EstebanAllende 1/24/2013 18:07'!
blockBody
	^ super blockBody ==> [ :nodes | 
		| result |
		result := RBBlockNode arguments: nodes first first body: nodes last.
		nodes first last isNil
			ifFalse: [ result bar: nodes first last start ].
		result ]! !

!GTSmalltalkParser methodsFor: 'private' stamp: 'EstebanAllende 1/24/2013 18:07'!
build: aNode assignment: anArray
	^ anArray isEmpty
		ifTrue: [ aNode ]
		ifFalse: [
			anArray reverse 
				inject: aNode
				into: [ :result :each |
					RBAssignmentNode 
						variable: each first
						value: result
						position: each second start ] ]! !

!GTSmalltalkParser methodsFor: 'private' stamp: 'EstebanAllende 1/24/2013 18:07'!
build: aNode cascade: anArray 
	| messages semicolons |
	^ (anArray isNil or: [ anArray isEmpty ]) 
		ifTrue: [ aNode ]
		ifFalse: [
			messages := OrderedCollection new: anArray size + 1.
			messages addLast: aNode.
			semicolons := OrderedCollection new.
			anArray do: [ :each | 
				messages addLast: (self 
					build: aNode receiver
					messages: (Array with: each second)).
				semicolons addLast: each first start ].
			RBCascadeNode messages: messages semicolons: semicolons ]! !

!GTSmalltalkParser methodsFor: 'private' stamp: 'EstebanAllende 1/24/2013 18:07'!
build: aNode messages: anArray 
	^ (anArray isNil or: [ anArray isEmpty ]) 
		ifTrue: [ aNode ]
		ifFalse: [
			anArray 
				inject: aNode
				into: [ :rec :msg | 
					msg isNil 
						ifTrue: [ rec ]
						ifFalse: [
							RBMessageNode 
								receiver: rec
								selectorParts: msg first
								arguments: msg second ] ] ]! !

!GTSmalltalkParser methodsFor: 'private' stamp: 'EstebanAllende 1/24/2013 18:07'!
build: aTempCollection sequence: aStatementCollection
	| result |
	result := self
		addStatements: aStatementCollection
		into: RBSequenceNode new.
	aTempCollection isEmpty ifFalse: [
		result
			leftBar: aTempCollection first start
			temporaries: aTempCollection second
			rightBar: aTempCollection last start ].
	^ result! !

!GTSmalltalkParser methodsFor: 'private' stamp: 'EstebanAllende 1/24/2013 18:07'!
buildArray: aStatementCollection
	^ self addStatements: aStatementCollection into: RBArrayNode new! !

!GTSmalltalkParser methodsFor: 'private' stamp: 'EstebanAllende 1/24/2013 18:07'!
buildMethod: aMethodNode
	aMethodNode selectorParts 
		do: [ :each | aMethodNode addComments: each comments ].
	aMethodNode arguments
		do: [ :each | aMethodNode addComments: each token comments ].
	aMethodNode pragmas do: [ :pragma |
		aMethodNode addComments: pragma comments.
		pragma selectorParts 
			do: [ :each | aMethodNode addComments: each comments ].
		pragma arguments do: [ :each | 
			each isLiteralArray
				ifFalse: [ aMethodNode addComments: each token comments ] ].
		pragma comments: nil ].
	^ aMethodNode! !

!GTSmalltalkParser methodsFor: 'private' stamp: 'EstebanAllende 1/24/2013 18:07'!
buildString: aString 
	(aString isEmpty or: [ aString first ~= $' or: [ aString last ~= $' ] ])
		ifTrue: [ ^ aString ].
	^ (aString 
		copyFrom: 2
		to: aString size - 1) 
		copyReplaceAll: ''''''
		with: ''''! !

!GTSmalltalkParser methodsFor: 'grammar-literals' stamp: 'EstebanAllende 1/24/2013 18:07'!
byteLiteral
	^ super byteLiteral ==> [ :nodes | RBLiteralArrayNode startPosition: nodes first start contents: nodes second stopPosition: nodes last start isByteArray: true ]! !

!GTSmalltalkParser methodsFor: 'grammar-literals' stamp: 'EstebanAllende 1/24/2013 18:07'!
byteLiteralArray
	^ super byteLiteralArray ==> [ :nodes | RBLiteralArrayNode startPosition: nodes first start contents: nodes second stopPosition: nodes last start isByteArray: true ]! !

!GTSmalltalkParser methodsFor: 'grammar-messages' stamp: 'EstebanAllende 1/24/2013 18:07'!
cascadeExpression
	^ super cascadeExpression map: [ :receiverNode :messageNodes | self build: receiverNode cascade: messageNodes ]! !

!GTSmalltalkParser methodsFor: 'grammar-literals' stamp: 'EstebanAllende 2/28/2013 12:29'!
charLiteral
	^ super charLiteral ==> [ :token | RBLiteralValueNode literalToken: ((RBLiteralToken value: token inputValue second start: token start stop: token stop) comments: token comments; yourself) ]! !

!GTSmalltalkParser methodsFor: 'grammar' stamp: 'EstebanAllende 1/24/2013 18:07'!
expression
	^ super expression map: [ :variableNodes :expressionNodes | self build: expressionNodes assignment: variableNodes ]! !

!GTSmalltalkParser methodsFor: 'grammar-literals' stamp: 'EstebanAllende 2/28/2013 12:29'!
falseLiteral
	^ super falseLiteral ==> [ :token | RBLiteralValueNode literalToken: ((RBLiteralToken value: false start: token start stop: token stop) comments: token comments; yourself) ]! !

!GTSmalltalkParser methodsFor: 'token' stamp: 'EstebanAllende 2/28/2013 12:30'!
identifierToken
	^ super identifierToken ==> [ :token | (RBIdentifierToken value: token inputValue start: token start) comments: token comments; yourself ]! !

!GTSmalltalkParser methodsFor: 'grammar-messages' stamp: 'EstebanAllende 1/24/2013 18:07'!
keywordExpression
	^ super keywordExpression map: [ :receiveNode :messageNode | self build: receiveNode messages: (Array with: messageNode) ]! !

!GTSmalltalkParser methodsFor: 'token' stamp: 'EstebanAllende 2/28/2013 12:30'!
keywordToken
	^ super keywordToken ==> [ :token | (RBKeywordToken value: token inputValue start: token start) comments: token comments; yourself ]! !

!GTSmalltalkParser methodsFor: 'grammar' stamp: 'EstebanAllende 1/24/2013 18:07'!
method
	^ super method map: [ :methodNode :bodyNode | 
		methodNode pragmas: bodyNode first.
		methodNode body: bodyNode second.
		self buildMethod: methodNode ]! !

!GTSmalltalkParser methodsFor: 'grammar' stamp: 'EstebanAllende 1/24/2013 18:07'!
methodSequence
	^ super methodSequence map: [ :periodNodes1 :pragmaNodes1 :periodNodes2 :tempNodes :periodNodes3 :pragmaNodes2 :periodNodes4 :statementNodes |
		Array
			with: pragmaNodes1 , pragmaNodes2
			with: (self build: tempNodes sequence: periodNodes1 , periodNodes2 , periodNodes3 , periodNodes4 , statementNodes) ]! !

!GTSmalltalkParser methodsFor: 'grammar-literals' stamp: 'EstebanAllende 2/28/2013 12:32'!
nilLiteral
	^ super nilLiteral ==> [ :token | RBLiteralValueNode literalToken: ((RBLiteralToken value: nil start: token start stop: token stop) comments: token comments; yourself) ]! !

!GTSmalltalkParser methodsFor: 'grammar-literals' stamp: 'EstebanAllende 2/28/2013 12:32'!
numberLiteral
	^ super numberLiteral ==> [ :token | RBLiteralValueNode literalToken: ((RBNumberLiteralToken value: (Number readSmalltalkSyntaxFrom: token inputValue) start: token start stop: token stop source: token inputValue) comments: token comments; yourself) ]! !

!GTSmalltalkParser methodsFor: 'grammar' stamp: 'EstebanAllende 1/24/2013 18:07'!
pragma
	^ super pragma ==> [ :nodes | 
		(RBPragmaNode selectorParts: nodes second first arguments: nodes second second)
			addComments: nodes first comments;
			addComments: nodes last comments;
			left: nodes first start;
			right: nodes last start;
			yourself ]! !

!GTSmalltalkParser methodsFor: 'grammar' stamp: 'EstebanAllende 1/24/2013 18:07'!
return
	^ super return map: [ :token :expressionNode | RBReturnNode return: token start value: expressionNode ]! !

!GTSmalltalkParser methodsFor: 'grammar' stamp: 'EstebanAllende 1/24/2013 18:07'!
sequence
	^ super sequence map: [ :tempNodes :periodNodes :statementNodes | self build: tempNodes sequence: periodNodes , statementNodes ]! !

!GTSmalltalkParser methodsFor: 'accessing' stamp: 'EstebanAllende 1/24/2013 18:07'!
startExpression
	"Make the sequence node has a method node as its parent and that the source is set."

	^ ([ :stream | stream collection ] asParser and , super startExpression) map: [ :source :node | 
		(RBMethodNode selector: #doIt body: node)
			source: source.
		(node statements size = 1 and: [ node temporaries isEmpty ])
			ifTrue: [ node statements first ]
			ifFalse: [ node ] ]! !

!GTSmalltalkParser methodsFor: 'accessing' stamp: 'EstebanAllende 1/24/2013 18:07'!
startMethod
	"Make sure the method node has the source code properly set."
	
	^ ([ :stream | stream collection ] asParser and , super startMethod)
		map: [ :source :node | node source: source ]! !

!GTSmalltalkParser methodsFor: 'grammar-literals' stamp: 'EstebanAllende 2/28/2013 12:33'!
stringLiteral
	^ super stringLiteral ==> [ :token | RBLiteralValueNode literalToken: ((RBLiteralToken value: (self buildString: token inputValue) start: token start stop: token stop) comments: token comments; yourself) ]! !

!GTSmalltalkParser methodsFor: 'grammar-literals' stamp: 'EstebanAllende 2/28/2013 12:34'!
symbolLiteral
	^ super symbolLiteral ==> [ :tokens | RBLiteralValueNode literalToken: ((RBLiteralToken value: (self buildString: tokens last inputValue) asSymbol start: tokens first start stop: tokens last stop) comments: tokens last comments; yourself) ]! !

!GTSmalltalkParser methodsFor: 'grammar-literals' stamp: 'EstebanAllende 2/28/2013 12:35'!
symbolLiteralArray
	^ super symbolLiteralArray ==> [ :token | RBLiteralValueNode literalToken: ((RBLiteralToken value: (self buildString: token inputValue) asSymbol start: token start stop: token stop) comments: token comments; yourself) ]! !

!GTSmalltalkParser methodsFor: 'grammar-literals' stamp: 'EstebanAllende 2/28/2013 12:35'!
trueLiteral
	^ super trueLiteral ==> [ :token | RBLiteralValueNode literalToken: ((RBLiteralToken value: true start: token start stop: token stop) comments: token comments; yourself) ]! !

!GTSmalltalkParser methodsFor: 'grammar-messages' stamp: 'EstebanAllende 1/24/2013 18:07'!
unaryExpression
	^ super unaryExpression map: [ :receiverNode :messageNodes | self build: receiverNode messages: messageNodes ]! !

!GTSmalltalkParser methodsFor: 'token' stamp: 'EstebanAllende 2/28/2013 12:35'!
unaryToken
	^ super unaryToken ==> [ :token | (RBIdentifierToken value: token inputValue start: token start) comments: token comments; yourself ]! !

!GTSmalltalkParser methodsFor: 'grammar' stamp: 'EstebanAllende 1/24/2013 18:07'!
variable
	^ super variable ==> [ :token | RBVariableNode identifierToken: token ]! !

GTSmalltalkParser subclass: #GradualtalkParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Gradualtalk-Parser'!

GradualtalkParser class
	instanceVariableNames: 'cache'!

GradualtalkParser class
	instanceVariableNames: 'cache'!

!GradualtalkParser class methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 3/19/2013 18:34'!
cleanCache
	cache := nil.! !

!GradualtalkParser class methodsFor: 'accessing' stamp: 'EstebanAllende 2/28/2013 12:56'!
defaultType
	<Gradualtalk: #bootstrap>
	^ nil! !

!GradualtalkParser class methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 3/19/2013 18:33'!
initialize
	cache := nil.! !

!GradualtalkParser class methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 3/19/2013 18:33'!
new
	^cache ifNil: [ cache := super new ].! !

!GradualtalkParser methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 2/28/2013 12:58'!
blockArgument
	^ super blockArgument
		==> [:nodes | nodes third propertyAt: #type put: (nodes second ifNil: [GradualtalkParser defaultType]) ; yourself]! !

!GradualtalkParser methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 2/28/2013 12:59'!
build: aTempCollection sequence: aStatementCollection
	| result |
	result := self
		addStatements: aStatementCollection
		into: RBSequenceNode new.
	aTempCollection isEmpty ifFalse: [
		result
			leftBar: aTempCollection first start
			temporaries: (aTempCollection second collect: [:nodes | nodes second propertyAt:#type put: (nodes first ifNil:[GradualtalkParser defaultType]); yourself]) 
			rightBar: aTempCollection last start ].
	^ result! !

!GradualtalkParser methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 1/24/2013 18:09'!
cast
	^ super cast ==> [:nodes| {nodes second. nodes first start. nodes last stop}]! !

!GradualtalkParser methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 1/24/2013 18:09'!
classVariableParser
	^ super classVariableGrammar! !

!GradualtalkParser methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 1/24/2013 18:09'!
methodDeclaration
	^ super methodDeclaration
		==> [:nodes | RBMethodNode selectorParts: nodes first arguments: nodes second paramTypes: nodes third returnType:  nodes fourth]! !

!GradualtalkParser methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 2/20/2013 12:51'!
oldClassVariableParser
	^ super oldClassVariableGrammar ==> [:nodes| nodes collect: [:each| {each first name asSymbol. each third}]].! !

!GradualtalkParser methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 1/24/2013 18:09'!
parametricVariableParser
	"^ (variable, ('<:' asParser, type) optional) star"
	^ super parametricVariableGrammar ==> [:nodes| nodes collect: [:each| {each second ifNotNil: [each second second]. each first}]]! !

!GradualtalkParser methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 1/24/2013 18:09'!
parenType
	^ super parenType ==> [:nodes |
		"|parenList|
		parenList := nodes second parens.
		parenList addFirst: nodes first.
		parenList addLast: nodes last."
		nodes second 
		]! !

!GradualtalkParser methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 3/30/2013 13:08'!
parens
	^ super parens
		map: [:openToken :castExpr :expressionNode :closeToken | 
			expressionNode
				addParenthesis: (openToken start to: closeToken start).
			castExpr ifNotNil: [
				 CastExpr addCast: (CastExpr explicitToType: castExpr first) to: expressionNode].
			castExpr ifNotNil: [ 
					(expressionNode addAsLastCast: castExpr first) makeExplicit.
				 ].
			expressionNode]! !

!GradualtalkGrammar methodsFor: 'grammar-methods' stamp: 'EstebanAllende 1/24/2013 18:07'!
binaryMethod
	^ parenType optional , binaryToken , parenType optional , variable
		==> [:nodes | Array
				with: (Array with: nodes second)
				with: (Array with: nodes fourth)
				with: {nodes third}
				with: (nodes first)]! !

!GradualtalkGrammar methodsFor: 'grammar-types' stamp: 'EstebanAllende 1/24/2013 18:07'!
blockArgument
	^ $: asParser smalltalkToken , parenType optional, variable! !

!GradualtalkGrammar methodsFor: 'bootstrap' stamp: 'EstebanAllende 2/28/2013 13:09'!
bootstrapType
	^((parenToken negate star), (parenType / cast / '->' asParser)) star, (parenToken negate star)! !

!GradualtalkGrammar methodsFor: 'grammar-types' stamp: 'EstebanAllende 1/24/2013 18:07'!
cast
	^$< asParser smalltalkToken, type, $> asParser smalltalkToken! !

!GradualtalkGrammar methodsFor: 'grammar' stamp: 'EstebanAllende 1/24/2013 18:07'!
classVariableGrammar
	^  (parenType optional , variable) star ! !

!GradualtalkGrammar methodsFor: 'grammar-methods' stamp: 'EstebanAllende 1/24/2013 18:07'!
keywordMethod
	^ parenType optional , (keywordToken , parenType optional , variable) plus
		==> [:nodes | Array
				with: (nodes second
						collect: [:each | each first])
				with: (nodes second
						collect: [:each | each third])
				with: (nodes second
						collect: [:each | each second])
				with: (nodes first)]! !

!GradualtalkGrammar methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 2/20/2013 12:50'!
oldClassVariableGrammar
	^  (variable, ':=' asParser smalltalkToken , type) star! !

!GradualtalkGrammar methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 1/24/2013 18:07'!
parametricVariableGrammar
	"^  (parenType optional , variable) star "
	^ (variable, ('<:' asParser, type) optional) star! !

!GradualtalkGrammar methodsFor: 'bootstrap' stamp: 'EstebanAllende 2/28/2013 13:06'!
parenToken
	^($( asParser / $) asParser / $< asParser / $> asParser)! !

!GradualtalkGrammar methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 2/28/2013 13:07'!
parenType

	^$( asParser, type, $) asParser! !

!GradualtalkGrammar methodsFor: 'grammar' stamp: 'EstebanAllende 1/24/2013 18:07'!
parens
	^ $( asParser smalltalkToken , cast optional, expression , $) asParser smalltalkToken! !

!GradualtalkGrammar methodsFor: 'grammar' stamp: 'EstebanAllende 1/24/2013 18:07'!
temporaries
	^ ($| asParser smalltalkToken , (parenType optional, variable) star , $| asParser smalltalkToken) optional
		==> [:nodes | nodes
				ifNil: [#()]]! !

!GradualtalkGrammar methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 2/28/2013 13:11'!
type
	<Gradualtalk: #bootstrap>
	^bootstrapType.! !

!GradualtalkGrammar methodsFor: 'grammar-methods' stamp: 'EstebanAllende 1/24/2013 18:07'!
unaryMethod
	^ parenType optional, identifierToken
		==> [:nodes | Array
				with: (Array with: nodes second)
				with: Array new
				with: Array new
				with: (nodes first)]! !

PPTokenParser subclass: #GTSmalltalkTokenParser
	instanceVariableNames: ''
	classVariableNames: 'SeparatorPredicate'
	poolDictionaries: ''
	category: 'Gradualtalk-Parser'!

!GTSmalltalkTokenParser commentStamp: '<historical>' prior: 0!
A parser that knows how to skip comments and whitespace in Smalltalk and how to instantiate tokens.
!

!GTSmalltalkTokenParser class methodsFor: 'initialization' stamp: 'EstebanAllende 1/25/2013 17:56'!
initialize
	SeparatorPredicate := PPCharSetPredicate on: [ :char | char isSeparator ]! !

!GTSmalltalkTokenParser methodsFor: 'private' stamp: 'EstebanAllende 1/25/2013 17:57'!
defaultTokenClass
	^ GTSmalltalkToken! !

!GTSmalltalkTokenParser methodsFor: 'parsing' stamp: 'EstebanAllende 1/25/2013 17:56'!
parseComments: anArray on: aStream
	| start comments |
	comments := anArray.
	[ [ aStream atEnd not and: [ SeparatorPredicate value: aStream uncheckedPeek ] ]
		whileTrue: [ aStream next ].
	 aStream atEnd not and: [ aStream uncheckedPeek = $" ] ] whileTrue: [
		aStream next.
		start := aStream position.
		aStream upTo: $".
		comments := comments copyWith: (start to: aStream position) ].
	^ comments! !

!GTSmalltalkTokenParser methodsFor: 'parsing' stamp: 'EstebanAllende 1/25/2013 17:56'!
parseOn: aStream
	| start comments token |
	start := aStream position.
	comments := self
		parseComments: #()
		on: aStream.
	token := super parseOn: aStream.
	token isPetitFailure ifTrue: [
		aStream position: start.
		^ token ].
	comments := self
		parseComments: comments
		on: aStream.
	^ token comments: comments! !

Object subclass: #GTClassVariableDeclarationParser
	instanceVariableNames: 'ivar cvar parser paramParser class'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Gradualtalk-Parser'!

!GTClassVariableDeclarationParser methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 3/20/2013 16:52'!
annotateVars
	<Gradualtalk: #bootstrap>! !

!GTClassVariableDeclarationParser methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 2/28/2013 12:49'!
class: aSymbol
	class := aSymbol.! !

!GTClassVariableDeclarationParser methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 2/28/2013 12:49'!
cvar: aString
	cvar := parser parse: aString.! !

!GTClassVariableDeclarationParser methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 2/28/2013 12:49'!
initialize
	parser := GradualtalkParser new classVariableParser.
	paramParser :=  GradualtalkParser new classVariableParser end / GradualtalkParser new parametricVariableParser end.
	cvar := #().
	ivar := #().! !

!GTClassVariableDeclarationParser methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 2/28/2013 12:49'!
ivar: aString
	ivar := parser parse: aString.! !

!GTClassVariableDeclarationParser methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 2/28/2013 12:49'!
oldCvar
	^' ' join: (cvar collect: [:each| each second name])! !

!GTClassVariableDeclarationParser methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 2/28/2013 12:49'!
oldIvar
	^' ' join: (ivar collect: [:each| each second name])! !

Object subclass: #GTVariablesParser
	instanceVariableNames: 'ivar cvar parser paramParser class'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Gradualtalk-Parser'!

!GTVariablesParser methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 3/20/2013 16:52'!
annotateVars
	<Gradualtalk: #bootstrap>! !

!GTVariablesParser methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/28/2011 01:46'!
class: aSymbol
	class := aSymbol.! !

!GTVariablesParser methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/28/2011 01:47'!
cvar: aString
	cvar := parser parse: aString.! !

!GTVariablesParser methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 1/24/2013 18:16'!
initialize
	parser := GradualtalkParser new classVariableParser.
	paramParser :=  GradualtalkParser new classVariableParser end / GradualtalkParser new parametricVariableParser end.
	cvar := #().
	ivar := #().! !

!GTVariablesParser methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/28/2011 01:46'!
ivar: aString
	ivar := parser parse: aString.! !

!GTVariablesParser methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/28/2011 01:47'!
oldCvar
	^' ' join: (cvar collect: [:each| each second name])! !

!GTVariablesParser methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/28/2011 01:47'!
oldIvar
	^' ' join: (ivar collect: [:each| each second name])! !
GTSmalltalkTokenParser initialize!
GradualtalkParser initialize!
